#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# IMPORTS
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

from local.typing import *;

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# GLOBAL VARIABLES/CONSTANTS
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# CLASS Stack
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

class Stack(object):
    values: List[int];

    def INIT(self):
        self.values = [];

    def EMPTY(self) -> bool:
        return len(self.values) == 0;

    def PUSH(self, x: int):
        self.values.append(x);

    def TOP(self) -> int:
        if self.EMPTY():
            raise Exception('Cannot pop from empty stack!')
        return self.values[-1];

    def POP(self) -> int:
        x = self.TOP()
        self.values = self.values[:-1]
        return x

    def __str__(self) -> str:
        if len(self.values) == 0:
            return '-';
        return ', '.join([str(x) for x in self.values]);
